Description

=begin

WIN32OLE_VARIANT.newの引数が配列かどうかで変換可否が変わります。

一貫性が無いので気になりました。

詳細：

WIN32OLE_VARIANT.new(Kernel)はTypeError: can not convert WIN32OLE_VARIANT from type Moduleとなります。

WIN32OLE_VARIANT.new([Kernel])は、KernelにIDispatchをラップしたWIN32OLEオブジェクトを生成します。

あるべき姿：

配列を指定した場合と同様、Rubyのオブジェクトでスカラ型に変換できないものはIDispatchのラッパーにするのが良いと思います。

ただし元々WIN32OLE_VARIANTが必要な事例が少ないので、修正する必要性については不明です。

=end

History

#1 - 10/09/2010 09:52 AM - suke (Masaki Suketa)

=begin

助田です。

On Sun, Oct 03, 2010 at 09:44:38PM +0900, Akio Tajima wrote:

WIN32OLE_VARIANT.new(Kernel)はTypeError: can not convert WIN32OLE_VARIANT from type Moduleとなります。

WIN32OLE_VARIANT.new([Kernel])は、KernelにIDispatchをラップしたWIN32OLEオブジェクトを生成します。

あるべき姿：

配列を指定した場合と同様、Rubyのオブジェクトでスカラ型に変換できないものはIDispatchのラッパーにするのが良いと思います。

 報告ありがとうございます。

統一することには同意です。

で、IDispatch のラッパーにした方が良い理由が何かありますか？

どちらかというと TypeError が、元々、私が意図した動作だったような気

がしています。

助田 雅紀

=end

#2 - 10/09/2010 10:12 AM - arton (Akio Tajima)

=begin

artonです。

で、IDispatch

のラッパーにした方が良い理由が何かありますか？

どちらかというと TypeError

が、元々、私が意図した動作だったような気

がしています。

意図はそうだと思いますが、IDispatchを与える(作る)方法と

してWIN32OLE_VARIANTはちょうど良い位置にあるからです。

もっとも、ユースケースは思いつかないのでどちらもTypeError

でも異論はないです。
=end

#3 - 03/18/2012 06:11 PM - nahi (Hiroshi Nakamura)

- Description updated

- Category set to ext

- Assignee set to suke (Masaki Suketa)

#4 - 03/18/2012 06:46 PM - shyouhei (Shyouhei Urabe)

- Status changed from Open to Assigned

#5 - 11/20/2012 09:24 PM - mame (Yusuke Endoh)

- Target version set to 2.6

#6 - 09/18/2014 03:59 PM - suke (Masaki Suketa)

- Status changed from Assigned to Closed

放置していてすみません。

2.2.0 では TypeErrorにすることにしました。
